<?php
if(file_exists("../../config/config_dir_raiz.php")) { require_once("../../config/config_dir_raiz.php"); } elseif(file_exists("config/config_dir_raiz.php")) { require_once("config/config_dir_raiz.php"); }

$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_area.php");
class Bi_areaDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_area)
	{
		$inputs = array();
		if($bi_area->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_area->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_area->getNome() != "")
		{
			array_push($inputs, array('campo'=>':nome', 'valor'=>$bi_area->getNome()));
		}
		else
		{
			array_push($inputs, array('campo'=>':nome', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_area (codigo, nome) VALUES (:codigo, :nome)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_area($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_area where codigo = :codigo "; 
		$bi_area = new Bi_area();
		$rows_bi_area = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_area as $row)
		{
			$bi_area->setCodigo($row['codigo']);
			$bi_area->setNome($row['nome']);
		}
		return $bi_area;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_area  ".$where;
		$lista_bi_area = array();
		$rows_bi_area = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_area as $row)
		{
			$bi_area = new Bi_area();
			$bi_area->setCodigo($row['codigo']);
			$bi_area->setNome($row['nome']);
			array_push($lista_bi_area, $bi_area);
		}
		return $lista_bi_area;
	}
	public function atualizar($bi_area)
	{
		$inputs = array();
		if($bi_area->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_area->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_area->getNome() != "")
		{
			array_push($inputs, array('campo'=>':nome', 'valor'=>$bi_area->getNome()));
		}
		else
		{
			array_push($inputs, array('campo'=>':nome', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_area  SET codigo = :codigo, nome = :nome WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_area)
	{
		try
		{
			$sql = "DELETE FROM bi_area  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_area->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_area";
		$listaBi_area = array();
		$rows_bi_area = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_area as $row)
		{
			$bi_area = new Bi_area();
			$bi_area->setCodigo($row['codigo']);
			$bi_area->setNome($row['nome']);
			array_push($listaBi_area,$bi_area );
		}
		return $listaBi_area;
	}
	public function buscarBi_areaPorNome($nome)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_area where nome like '%".$nome."%'";
		$lista_bi_area = array();
		$rows_bi_area = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_area as $row)
		{
			$bi_area = new Bi_area();
			$bi_area->setCodigo($row['codigo']);
			$bi_area->setNome($row['nome']);
			array_push($lista_bi_area, $bi_area);
		}
		return $lista_bi_area;
	}
}